;******************************************************************************
;*  FUNCTION	mul16x16_32.inc
;*  Mutiply 	16x16 -> 32 bit 		(unsigned * unsigned)
;*
;* 		AH  AL    BH  BL     E3 E2 E1 E0
;*  	R21:R20 x R17:R16 -> R5:R4:R3:R2
;*	
;*	Scrached Register:	-
;*  22 cycles + 4 (RET) = 26 Cycles
;*
;******************************************************************************
mul_16x16:
		push	R9
;   R5:R2 = R17:R16 * R21:R20
        sub		R9,R9            
		mul 	R20,R16					; AL * BL
		movw 	R3:R2,R1:R0
		mul 	R21,R17					; AH * BH
		movw 	R5:R4,R1:R0
		
		mul 	R21,R16					; AH * BL
		add		R3,R0
		adc		R4,R1
		adc		R5,R9
		
		mul		R20,R17					; AL * BH
		add		R3,R0
		adc		R4,R1
		adc		R5,R9
		pop		R9
		ret
