;******************************************************************************
;*  FUNCTION	mul24x16_40.inc
;*  Mutiply 	24x16 -> 40 bit 		(unsigned * unsigned)
;*
;* 		AH  AM  AL    BH  BL     E4 E3 E2 E1 E0
;*  	R22:R21:R20 x R17:R16 -> R6:R5:R4:R3:R2
;*	
;*	Scrached Register:	-
;*  36 cycles + 4 (RET) = 40 Cycles
;*
;******************************************************************************
mul_24x16:
		push	R9
;   R6:R2 = R17:R16 * R22:R20

		sub		R4,R4				; NULL
		sub		R9,R9
		mul 	R20,R16				; AL*BL
		movw 	R3:R2,R1:R0
		mul 	R22,R17				; AH*BH
		mov 	R5,R0
		mov 	R6,R1

		mul		R21,R16				; AM*BL
		add		R3,R0
		adc		R4,R1
		adc		R5,R9
		adc		R6,R9
		
		mul		R22,R16				; AH*BL
		add		R4,R0
		adc		R5,R1
		adc		R6,R9

		mul		R20,R17				; AL*BH
		add		R3,R0
		adc		R4,R1
		adc		R5,R9
		adc		R6,R9

		mul		R21,R17				; AM*BH
		add		R4,R0
		adc		R5,R1
		adc		R6,R9
		pop		R9		
		ret
