;******************************************************************************
;*  FUNCTION	mul24x24_48.inc
;*  Mutiply 	24x24 -> 48 bit 		(unsigned * unsigned)
;*
;* 		AH  AM  AL    BH  BM  BL     E5 E4 E3 E2 E1 E0
;*  	R22:R21:R20 x R18:R17:R16 -> R7:R6:R5:R4:R3:R2
;*	
;*	Scrached Register:	-
;*  53 cycles + 4 (RET) = 57 Cycles
;*
;******************************************************************************
mul_24x24:
		push	R9
		push	R10
		push	R11
		
;   R7:R2 = R18:R16 * R22:R20

		sub		R9,R9				; NULL
		mul 	R20,R16				; AL*BL
		movw 	R3:R2,R1:R0
		mul 	R22,R16				; AH*BL
		movw 	R5:R4,R1:R0
		mul 	R22,R18				; AH*BH
		movw 	R7:R6,R1:R0

		mul		R21,R16				; AM*BL
		movw	R11:R10,R1:R0
		mul		R22,R17				; AH*BM		
		add		R3,R10
		adc		R4,R11
		adc		R5,R0
		adc		R6,R1
		adc		R7,R9

		mul		R20,R17				; AL*BM
		movw	R11:R10,R1:R0
		mul		R21,R18				; AM*BH
		add		R3,R10
		adc		R4,R11
		adc		R5,R0
		adc		R6,R1
		adc		R7,R9
		
		mul		R21,R17				; AM*BM	
		add		R4,R0
		adc		R5,R1
		adc		R6,R9
		adc		R7,R9

		mul		R20,R18				; AL*BH
		add		R4,R0
		adc		R5,R1
		adc		R6,R9
		adc		R7,R9
				
		pop		R11
		pop		R10
		pop		R9
		ret
