;******************************************************************************
;*  FUNCTION	mul24x8_32.inc
;*  Mutiply 	24x8 -> 32 bit 		(unsigned * unsigned)
;*
;* 		AH  AM  AL    BL     E3 E2 E1 E0
;*  	R22:R21:R20 x R16 -> R5:R4:R3:R2
;*	
;*	Scrached Register:	-
;*  17 cycles + 4 (RET) = 21 Cycles
;*
;******************************************************************************
mul_24x8:
		push	R9
;   R5:R2 = R16 * R22:R20
		sub		R9,R9				; NULL
		mul 	R20,R16				; AL*BL
		movw 	R3:R2,R1:R0
		mul 	R22,R16				; AH*BL
		movw 	R5:R4,R1:R0

		mul		R21,R16				; AM*BL
		add		R3,R0
		adc		R4,R1
		adc		R5,R9
		pop		R9		
		ret
