;******************************************************************************
;*  FUNCTION	mul32x16_48.inc
;*  Mutiply 	32x16 -> 48 bit 		(unsigned * unsigned)
;*
;* 		AH  AM  AL  AXL   BH  BL     E5 E4 E3 E2 E1 E0
;*  	R23:R22:R21:R20 x R17:R16 -> R7:R6:R5:R4:R3:R2
;*	
;*	Scrached Register:	-
;*  45 cycles + 4 (RET) = 49 Cycles
;*
;******************************************************************************
mul_32x16:
		push	R9
;   R7:R2 = R17:R16 * R23:R20
		sub		R9,R9				; NULL
		mul 	R20,R16				; AXL*BL
		movw 	R3:R2,R1:R0
		mul 	R22,R16				; AM*BL
		movw 	R5:R4,R1:R0
		mul 	R23,R17				; AH*BH
		movw 	R7:R6,R1:R0

		mul		R21,R16				; AL*BL
		add		R3,R0
		adc		R4,R1
		adc		R5,R9
		adc		R6,R9
		adc		R7,R9
		
		mul		R23,R16				; AH*BL
		add		R5,R0
		adc		R6,R1
		adc		R7,R9
		
		mul		R20,R17				; AXL*BH
		add		R3,R0
		adc		R4,R1
		adc		R5,R9
		adc		R6,R9
		adc		R7,R9
		
		mul		R21,R17				; AL*BH
		add		R4,R0
		adc		R5,R1
		adc		R6,R9
		adc		R7,R9
		
		mul		R22,R17				; AM*BH
		add		R5,R0
		adc		R6,R1
		adc		R7,R9
		pop		R9
		ret
