;******************************************************************************
;*  FUNCTION	mul32x24_56.inc
;*  Mutiply 	32x24 -> 56 bit 		(unsigned * unsigned)
;*
;* 		AH  AM  AL  AXL   BH  BM  BL     E6 E5 E4 E3 E2 E1 E0
;*  	R23:R22:R21:R20 x R18:R17:R16 -> R8:R7:R6:R5:R4:R3:R2
;*	
;*	Scrached Register:	-
;*  71 cycles + 4 (RET) = 75 Cycles
;*
;******************************************************************************
mul_32x24:
		push	R9
		push	R10
		push	R11
		
;   R8:R2 = R18:R16 * R23:R20

		sub		R6,R6				; NULL
		sub		R9,R9				; NULL
		mul 	R20,R16				; AXL*BL
		movw 	R3:R2,R1:R0
		mul 	R22,R16				; AM*BL
		movw 	R5:R4,R1:R0
		mul 	R23,R18				; AH*BH
		mov 	R7,R0
		mov 	R8,R1

		mul		R21,R16				; AL*BL
		movw	R11:R10,R1:R0
		mul		R23,R16				; AH*BL		
		add		R3,R10
		adc		R4,R11
		adc		R5,R0
		adc		R6,R1
		adc		R7,R9
		adc		R8,R9

		mul		R20,R17				; AXL*BM
		movw	R11:R10,R1:R0
		mul		R22,R17				; AM*BM
		add		R3,R10
		adc		R4,R11
		adc		R5,R0
		adc		R6,R1
		adc		R7,R9
		adc		R8,R9
		
		mul		R21,R17				; AL*BM
		movw	R11:R10,R1:R0
		mul		R23,R17				; AH*BM		
		add		R4,R10
		adc		R5,R11
		adc		R6,R0
		adc		R7,R1
		adc		R8,R9

		mul		R20,R18				; AXL*BH
		movw	R11:R10,R1:R0
		mul		R22,R18				; AM*BH
		add		R4,R10
		adc		R5,R11
		adc		R6,R0
		adc		R7,R1
		adc		R8,R9
		
		mul		R21,R18				; AL*BH
		add		R5,R0
		adc		R6,R1
		adc		R7,R9
		adc		R8,R9
				
		pop		R11
		pop		R10
		pop		R9
		ret
