;******************************************************************************
;*  FUNCTION	mul32x32_64.inc
;*  Mutiply 	32x32 -> 64 bit 		(unsigned * unsigned)
;*
;* 		AH  AM  AL  AXL   BH  BM  BL  BXL    E7 E6 E5 E4 E3 E2 E1 E0
;*  	R23:R22:R21:R20 x R19:R18:R17:R16 -> R9:R8:R7:R6:R5:R4:R3:R2
;*	
;*	Scrached Register:	-
;*  98 cycles + 4 (RET) = 102 Cycles
;*
;******************************************************************************
mul_32x32:
		push	R10
		push	R11
		push	R12
		push	R13
		push	R14
		clr		R14

;   R9:R2 = R19:R16 * R23:R20

		sub R14,R14                  ; Null
                      
		mul 	R20,R16                ; AXL*BXL
		movw 	R3:R2,R1:R0
		mul 	R21,R17                ; AL*BL
		movw 	R5:R4,R1:R0
		mul 	R22,R18                ; AM*BM
		movw 	R7:R6,R1:R0  
		mul 	R23,R19                ; AH*BH
		movw 	R9:R8,R1:R0

		mul 	R22,R19                ; AH*BM
		movw 	R13:R12,R1:R0
		mul 	R21,R18                ; AM*BL
		movw 	R11:R10,R1:R0
		mul 	R20,R17                ; AL*BXL

		add 	R3, R0
		adc 	R4, R1
		adc 	R5, R10
		adc 	R6, R11
		adc 	R7, R12
		adc 	R8,R13
		adc 	R9,R14

		mul 	R23,R18                ; AM*BH
		movw 	R13:R12,R1:R0
		mul 	R22,R17                ; AL*BM
		movw 	R11:R10,R1:R0
		mul 	R21,R16                ; AXL*BL

		add 	R3, R0
		adc 	R4, R1
		adc 	R5, R10
		adc 	R6, R11
		adc 	R7, R12
		adc 	R8,R13
		adc 	R9,R14

		mul 	R21,R19                ; AH*BL
		movw 	R11:R10,R1:R0
		mul 	R20,R18                ; AM*BXL

		add 	R4, R0
		adc 	R5, R1
		adc 	R6, R10
		adc 	R7, R11
		adc 	R8,R14
		adc 	R9,R14

		mul 	R23,R17                ; AL*BH
		movw 	R11:R10,R1:R0
		mul 	R22,R16                ; AXL*BM

		add 	R4, R0
		adc 	R5, R1
		adc 	R6, R10
		adc 	R7, R11
		adc 	R8,R14
		adc 	R9,R14

		mul 	R20,R19                ; AH*BXL
		movw 	R11:R10,R1:R0
		mul 	R23,R16                ; AXL*BH

		add 	R5, R0
		adc 	R6, R1
		adc 	R7, R14
		adc 	R8,R14
		adc 	R9,R14

		add 	R5, R10
		adc 	R6, R11
		adc 	R7, R14
		adc 	R8,R14
		adc 	R9,R14
		pop		R14
		pop		R13
		pop		R12
		pop		R11
		pop		R10  
		ret
