;******************************************************************************
;*  FUNCTION	mul32x8_40.inc
;*  Mutiply 	32x8 -> 40 bit 		(unsigned * unsigned)
;*
;* 		AH  AM  AL  AXL   BL     E4 E3 E2 E1 E0
;*  	R23:R22:R21:R20 x R16 -> R6:R5:R4:R3:R2
;*	
;*	Scrached Register:	-
;*  25 cycles + 4 (RET) = 29 Cycles
;*
;******************************************************************************
mul_32x8:
		push	R9
;   R6:R2 = R16 * R23:R20

		sub		R4,R4				; NULL
        sub		R9,R9            
		mul 	R20,R16				; AXL*BL
		movw 	R3:R2,R1:R0 
		mul 	R23,R16				; AH*BL
		mov 	R5,R0
		mov 	R6,R1

		mul 	R21,R16				; AL*BL
		add		R3,R0
		adc		R4,R1
		adc		R5,R9
		adc		R6,R9

		mul 	R22,R16				; AM*BL
		add		R4,R0
		adc		R5,R1
		adc		R6,R9
		pop		R9
		ret
