;******************************************************************************
;*  FUNCTION	muls16x16_32.inc
;*  Mutiply 	16x16 -> 32 bit 		(signed * signed)
;*
;* 		AH  AL    BH  BL     E3 E2 E1 E0
;*  	R21:R20 x R17:R16 -> R5:R4:R3:R2
;*	
;*	Scrached Register:	-
;*  13 cycles + 4 (RET) = 17 Cycles
;*
;******************************************************************************
muls_16x16:
		push	R10
		clr		R10
		muls	R21,R17			; (signed)ah * (signed)bh
		movw	R5:R4,R1:R0
		mul		R20,R16			; al * bl
		movw	R3:R2,R1:R0
		mulsu	R21, R16		; (signed)ah * bl
		sbc		R5, R10
		add		R3, R0
		adc		R4, R1
		adc		R5, R10
		mulsu	R17, R20		; (signed)bh * al
		sbc		R5, R10
		add		R3, R0
		adc		R4, R1
		adc		R5, R10
		pop		R10
		ret
