;***********************************************************************************
;*
;*		FUNCTION	muls32x8_40.inc
;*		Mutiply 	32x8 -> 40 bit			(signed * signed)
;*
;*      AH  AM  AL  AXL   BL     E4 E3 E2 E1 E0
;*      R23:R22:R21:R20 x R16 -> R6:R5:R4:R3:R2
;*
;*  34 cycles + 4 (RET) = 38 Cycles
;*
;***********************************************************************************
muls_32x8:
		push	R10
		clr		R4
		sub		R10,R10			; NULL

		muls	R23,R16			; AH x BL			(s*s)
		mov		R5,R0
		mov		R6,R1
		
		mulsu	R16,R20			; BL x AXL			(s*u)
		sbc		R4,R10
		sbc		R5,R10
		sbc		R6,R10
		movw	R3:R2,R1:R0
		adc		R4,R10
		adc		R5,R10
		adc		R6,R10
		
		mulsu	R16,R21			; BL x AL			(s*u)
		sbc		R5,R10			; signed DUMMY
		sbc		R6,R10			; signed DUMMY
		add		R3,R0
		adc		R4,R1
		adc		R5,R10
		adc		R6,R10
		
		mulsu	R16,R22			; BL x AM			(s*u)
		sbc		R6,R10			; signed DUMMY
		add		R4,R0
		adc		R5,R1
		adc		R6,R10
		
		pop		R10
		ret

/*
muls_32x8:
		push	R10
		clr		R2
		clr		R3
		clr		R4
		clr		R5
		clr		R6
		sub		R10,R10			; NULL
		
		mulsu	R16,R20			; BL x AXL			(s*u)
		sbc		R4,R10
		sbc		R5,R10
		sbc		R6,R10
;		movw	R3:R2,R1:R0
		add		R2,R0
		adc		R3,R1
		adc		R4,R10
		adc		R5,R10
		adc		R6,R10

		muls	R23,R16			; AH x BL			(s*s)
;		mov		R5,R0
;		mov		R6,R1
		add		R5,R0
		adc		R6,R1
		
		mulsu	R16,R21			; BL x AL			(s*u)
		sbc		R5,R10			; signed DUMMY
		sbc		R6,R10			; signed DUMMY
		add		R3,R0
		adc		R4,R1
		adc		R5,R10
		adc		R6,R10
		
		mulsu	R16,R22			; BL x AM			(s*u)
		sbc		R6,R10			; signed DUMMY
		add		R4,R0
		adc		R5,R1
		adc		R6,R10
		
		pop		R10
		ret
*/