;******************************************************************************
;*  FUNCTION	mulsu16x16_32.inc
;*  Mutiply 	16x16 -> 32 bit 		(signed * unsigned)
;*
;* 		AH  AL    BH  BL     E3 E2 E1 E0
;*  	R21:R20 x R17:R16 -> R5:R4:R3:R2
;*	
;*	Scrached Register:	-
;*  23 cycles + 4 (RET) = 27 Cycles
;*
;******************************************************************************
mulsu_16x16:
		push	R10
		sub		R10,R10			; NULL
		
		mul		R20,R16			; AL x BL		(u*u)
		movw	R3:R2,R1:R0
		mulsu	R21,R17			; AH x BH		(s*u)
		movw	R5:R4,R1:R0
		
		mulsu	R21,R16			; AH x BL		(s*u)
		sbc		R5,R10
		add		R3,R0
		adc		R4,R1
		adc		R5,R10
		
		mul		R20,R17			; AL x BH		(u*u)
		add		R3,R0
		adc		R4,R1
		adc		R5,R10
		pop		R10
		ret
