;***********************************************************************************
;*
;*		FUNCTION	mulsu24x16_40.inc
;*		Mutiply 	24x16 -> 40 bit			(signed * unsigned)
;*
;*      AH  AM  AL    BH  BL     E4 E3 E2 E1 E0
;*      R22:R21:R20 x R17:R16 -> R6:R5:R4:R3:R2
;*
;*  37 cycles + 4 (RET) = 41 Cycles
;*
;***********************************************************************************
mulsu_24x16:
		push	R10
		clr		R4
		sub		R10,R10			; NULL
		
		mul		R20,R16			; AL x BL		(u*u)
		movw	R3:R2,R1:R0		
		mulsu	R22,R17			; AH x BH		(s*u)
		mov		R5,R0
		mov		R6,R1
		
		mul		R21,R16			; AM x BL		(u*u)
		add		R3,R0
		adc		R4,R1
		adc		R5,R10
		adc		R6,R10
		
		mulsu	R22,R16			; AH x BL		(s*u)
		sbc		R6,R10
		add		R4,R0
		adc		R5,R1
		adc		R6,R10

		mul		R20,R17			; AL x BH		(u*u)
		add		R3,R0
		adc		R4,R1
		adc		R5,R10
		adc		R6,R10
		
		mul		R21,R17			; AM x BH		(u*u)
		add		R4,R0
		adc		R5,R1
		adc		R6,R10
		
		pop		R10
		ret