;***********************************************************************************
;*
;*		FUNCTION	mulsu24x24_48.inc
;*		Mutiply 	24x24 -> 48 bit			(signed * unsigned)
;*
;*      AH  AM  AL    BH  BM  BL     E5 E4 E3 E2 E1 E0
;*      R22:R21:R20 x R18:R17:R16 -> R7:R6:R5:R4:R3:R2
;*
;*  56 cycles + 4 (RET) = 60 Cycles
;*
;***********************************************************************************
mulsu_24x24:
		push	R8
		push	R9
		push	R10
		sub		R10,R10			; NULL
		mul		R20,R16			; AL x BL		(u*u)
		movw	R3:R2,R1:R0
		mul		R21,R17			; AM x BM		(u*u)
		movw	R5:R4,R1:R0
		mulsu	R22,R17			; AH x BH		(s*u)
		movw	R7:R6,R1:R0
		
		mulsu	R22,R17			; AH x BM		(s*u)
		sbc		R7,R10			; signed DUMMY
		movw	R9:R8,R1:R0
		mul		R21,R16			; AM x BL		(u*u)
		add		R3,R0
		adc		R4,R1
		adc		R5,R8
		adc		R6,R9
		adc		R7,R10
		
		mul		R21,R18			; AM x BH		(u*u)
		movw	R9:R8,R1:R0
		mul		R20,R17			; AL x BM		(u*u)
		add		R3,R0
		adc		R4,R1
		adc		R5,R8
		adc		R6,R9
		adc		R7,R10

		mulsu	R22,R16			; AH x BL		(s*u)
		sbc		R6,R10			; signed DUMMY
		sbc		R7,R10			; signed DUMMY
		add		R4,R0
		adc		R5,R1
		adc		R6,R10
		adc		R7,R10

		mul		R20,R18			; AL x BH		(u*u)
		add		R4,R0
		adc		R5,R1
		adc		R6,R10
		adc		R7,R10
		pop		R10
		pop		R9
		pop		R8  
		ret