;***********************************************************************************
;*
;*		FUNCTION	mulsu32x24_56.inc
;*		Mutiply 	32x24 -> 56 bit			(signed * unsigned)
;*
;*      AH  AM  AL  AXL   BH  BM  BL     E6 E5 E4 E3 E2 E1 E0
;*      R23:R22:R21:R20 x R18:R17:R16 -> R8:R7:R6:R5:R4:R3:R2
;*
;*  74 cycles + 4 (RET) = 78 Cycles
;*
;***********************************************************************************
mulsu_32x24:
		push	R9
		push	R10
		push	R11	
		sub		R9,R9
		clr		R6
		mul		R20,R16			; AXL x BL		(u*u)
		movw	R3:R2,R1:R0
		mul		R22,R16			; AM x BL		(u*u)
		movw	R5:R4,R1:R0
		mulsu	R23,R18			; AH x BH		(s*u)
		mov		R7,R0
		mov		R8,R1			

		mul		R21,R16			; AL x BL		(u*u)
		movw	R11:R10,R1:R0
		mulsu	R23,R16			; AH x BL		(s*u)
		sbc		R7,R9			; signed DUMMY
		sbc		R8,R9			; signed DUMMY
		add		R3,R10
		adc		R4,R11
		adc		R5,R0
		adc		R6,R1
		adc		R7,R9
		adc		R8,R9
		
		mul		R20,R17			; AXL x BM		(u*u)
		movw	R11:R10,R1:R0
		mul		R21,R18			; AL x BH		(u*u)
		add		R3,R10
		adc		R4,R11
		adc		R5,R0
		adc		R6,R1
		adc		R7,R9
		adc		R8,R9

		mul		R21,R17			; AL x BM		(u*u)
		movw	R11:R10,R1:R0
		mulsu	R23,R17			; AH x BM		(s*u)
		sbc		R8,R9			; signed DUMMY
		add		R4,R10
		adc		R5,R11
		adc		R6,R0
		adc		R7,R1
		adc		R8,R9
		
		mul		R22,R17			; AM*BM			(u*u)
		add		R5,R0
		adc		R6,R1
		adc		R7,R9
		adc		R8,R9
		
		mul		R20,R18			; AXL x BH		(u*u)
		movw	R11:R10,R1:R0
		mul		R22,R18			; AM x BH		(u*u)
		add		R4,R10
		adc		R5,R11
		adc		R6,R0
		adc		R7,R1
		adc		R8,R9
		
		pop		R11
		pop		R10
		pop		R9	
		ret
