;***********************************************************************************
;*
;*		FUNCTION	mulsu32x32_64.inc
;*		Mutiply 	32x32 -> 64 bit			(signed * unsigned)
;*
;*      AH  AM  AL  AXL   BH  BM  BL  BXL    E7 E6 E5 E4 E3 E2 E1 E0
;*      R23:R22:R21:R20 x R19:R18:R17:R16 -> R9:R8:R7:R6:R5:R4:R3:R2
;*
;*  102 cycles + 4 (RET) = 106 Cycles
;*
;***********************************************************************************
mulsu_32x32:
		push	R10
		push	R11
		push	R12
		push	R13
		push	R14
		sub		R14,R14			; NULL
		
		mul		R20,R16			; AXL x BXL		(u*u)
		movw	R3:R2,R1:R0
		mul		R21,R17			; AL x BL		(u*u)
		movw	R5:R4,R1:R0
		mul		R22,R18			; AM x BM		(u*u)
		movw	R7:R6,R1:R0
		mulsu	R23,R19			; AH x BH		(s*u)
		movw	R9:R8,R1:R0		

		mul		R20,R17			; AXL x BL		(u*u)
		movw	R11:R10,R1:R0
		mul		R21,R18			; AL x BM		(u*u)
		movw	R13:R12,R1:R0
		mul		R22,R19			; AM x BH		(u*u)	
		add		R3,R10
		adc		R4,R11
		adc		R5,R12
		adc		R6,R13
		adc		R7,R0
		adc		R8,R1
		adc		R9,R14
		
		mul		R21,R16			; AL x BXL		(u*u)
		movw	R11:R10,R1:R0
		mul		R22,R17			; AM x BL		(u*u)
		movw	R13:R12,R1:R0
		mulsu	R23,R18			; AH x BM		(s*u)
		sbc		R9,R14
		add		R3,R10
		adc		R4,R11
		adc		R5,R12
		adc		R6,R13
		adc		R7,R0
		adc		R8,R1
		adc		R9,R14
				
		mul		R20,R18			; AXL x BM		(u*u)
		movw	R11:R10,R1:R0
		mul		R21,R19			; AL x BH		(u*u)
		add		R4,R10
		adc		R5,R11
		adc		R6,R0
		adc		R7,R1
		adc		R8,R14
		adc		R9,R14

		mul		R22,R16			; AM x BXL		(u*u)
		movw	R11:R10,R1:R0
		mulsu	R23,R17			; AH x BL		(s*u)
		sbc		R8,R14			; signed DUMMY
		sbc		R9,R14			; signed DUMMY
		add		R4,R10
		adc		R5,R11
		adc		R6,R0
		adc		R7,R1
		adc		R8,R14
		adc		R9,R14

		mulsu	R23,R16			; AH*BXL		(s*u)
		sbc		R7,R14
		sbc		R8,R14
		sbc		R9,R14
		add		R5,R0
		adc		R6,R1
		adc		R7,R14
		adc		R8,R14
		adc		R9,R14
		
		mul		R20,R19			; AXL x BH		(u*u)
		add		R5,R0
		adc		R6,R1
		adc		R7,R14
		adc		R8,R14
		adc		R9,R14
		
		pop		R14
		pop		R13
		pop		R12
		pop		R11
		pop		R10	
		ret
